package fishrungames.yelpmapapp.asyncTasks

import android.os.AsyncTask
import com.google.gson.JsonObject
import com.google.gson.Gson
import com.google.gson.reflect.TypeToken
import fishrungames.yelpmapapp.records.BusinessDetailRecord
import fishrungames.yelpmapapp.records.MapMarkerRecord


/**
 * Created by mephi on 10.06.2017.
 */


class HandleBusinessDetailResponseAsyncTask(val onUpdateBusinessDetail : ((BusinessDetailRecord?) -> Unit)) : AsyncTask<JsonObject, Int, BusinessDetailRecord?>()
{


    override fun doInBackground(vararg response : JsonObject): BusinessDetailRecord? {

        var result : BusinessDetailRecord? = null

        try {

            val recordType = object : TypeToken<BusinessDetailRecord?>() {}.type

            result = Gson().fromJson<BusinessDetailRecord?>(response[0], recordType)

        }
        catch (e : Exception)
        {
            e.printStackTrace()

        }

        return result
    }

    override fun onPostExecute(result: BusinessDetailRecord?) {

        super.onPostExecute(result)

        onUpdateBusinessDetail(result)

    }
}